import openpyxl
from datetime import datetime


def create_excel_result(callback, config):
    # Öffnen Sie eine neue Excel-Arbeitsmappe
    workbook = openpyxl.Workbook()

    # Fügen Sie ein neues Arbeitsblatt hinzu
    worksheet = workbook.active

    # Setzen Sie die Spaltenbreite auf 19 Pixel
    worksheet.column_dimensions["A"].width = 6
    worksheet.column_dimensions["B"].width = 19
    worksheet.column_dimensions["C"].width = 19
    worksheet.column_dimensions["D"].width = 19
    worksheet.column_dimensions["E"].width = 19
    worksheet.column_dimensions["F"].width = 19
    worksheet.column_dimensions["G"].width = 19
    worksheet.column_dimensions["H"].width = 19
    worksheet.column_dimensions["I"].width = 19
    worksheet.column_dimensions["J"].width = 12

    # Basis Configurationen hier beschreiben
    # TODO: Implementieren der Excluded Folder, Aktivierungsfunktion (128 Einheiten, 1 Einheit), Optimierungsverfahren

    # Schreiben Sie die Überschriften in die erste Zeile
    # TODO: Ergänzung Recall 1, Recall 2
    worksheet.cell(row=1, column=1).value = 'epoch'
    worksheet.cell(row=1, column=2).value = 'training_loss'
    worksheet.cell(row=1, column=3).value = 'training_accuracy'
    worksheet.cell(row=1, column=4).value = 'training_recall_not_oos'
    worksheet.cell(row=1, column=5).value = 'training_recall_oos'
    worksheet.cell(row=1, column=6).value = 'test_loss'
    worksheet.cell(row=1, column=7).value = 'test_accuracy'
    worksheet.cell(row=1, column=8).value = 'test_recall_not_oos'
    worksheet.cell(row=1, column=9).value = 'test_recall_oos'
    worksheet.cell(row=1, column=10).value = 'duration'

    # Schreiben Sie die Ergebnisse der Epochen in die Arbeitsmappe
    for i, (loss, accuracy, recall_not_oos, recall_oos,
            val_loss, val_accuracy, val_recall_not_oos, val_recall_oos, duration) in enumerate(
            zip(callback.epoch_training_losses, callback.epoch_training_accuracies,
                callback.epoch_training_recall_not_oos, callback.epoch_training_recall_oos,
                callback.epoch_test_losses, callback.epoch_test_accuracies, callback.epoch_test_recall_not_oos,
                callback.epoch_test_recall_oos, callback.epoch_durations)):
        worksheet.cell(row=i + 2, column=1).value = i + 1
        worksheet.cell(row=i + 2, column=2).value = loss
        worksheet.cell(row=i + 2, column=3).value = accuracy
        worksheet.cell(row=i + 2, column=4).value = recall_not_oos
        worksheet.cell(row=i + 2, column=5).value = recall_oos
        worksheet.cell(row=i + 2, column=6).value = val_loss
        worksheet.cell(row=i + 2, column=7).value = val_accuracy
        worksheet.cell(row=i + 2, column=8).value = val_recall_not_oos
        worksheet.cell(row=i + 2, column=9).value = val_recall_oos
        worksheet.cell(row=i + 2, column=10).value = duration

    now = datetime.now()
    date_time = now.strftime("%d_%m_%y__%H_%M")
    file_name = "epoch_results_" + date_time + ".xlsx"
    # Speichern Sie die Arbeitsmappe
    workbook.save(config["result"]["excel_path"] + file_name)

    # Abschlussbericht definieren
    # TODO: Implementierung Evaluation mit Excluded Folder, Accuracy, Recall 1, Recall 2


# TODO: Abschluss Statistik nach Cross-Validation von einer Konfiguration: Durchschnitt Accuracy, Recall 1, Recall 2, Loss, Duration für Evaluation
